// Poductivity SDK version: 0.11.0 - Built March 11, 2021 13:05:46
'use strict';

const index = require('./index-4949b76c.js');
const appGlobals = require('./app-globals-a285ff58.js');

/*
 Stencil Client Patch Browser v2.4.0 | MIT Licensed | https://stenciljs.com
 */
const getDynamicImportFunction = (namespace) => `__sc_import_${namespace.replace(/\s|-/g, '_')}`;
const patchBrowser = () => {
    {
        // shim css vars
        index.plt.$cssShim$ = index.win.__cssshim;
    }
    // @ts-ignore
    const scriptElm =  Array.from(index.doc.querySelectorAll('script')).find(s => new RegExp(`\/${index.NAMESPACE}(\\.esm)?\\.js($|\\?|#)`).test(s.src) || s.getAttribute('data-stencil-namespace') === index.NAMESPACE)
        ;
    const opts =  {};
    if ( 'onbeforeload' in scriptElm && !history.scrollRestoration /* IS_ESM_BUILD */) {
        // Safari < v11 support: This IF is true if it's Safari below v11.
        // This fn cannot use async/await since Safari didn't support it until v11,
        // however, Safari 10 did support modules. Safari 10 also didn't support "nomodule",
        // so both the ESM file and nomodule file would get downloaded. Only Safari
        // has 'onbeforeload' in the script, and "history.scrollRestoration" was added
        // to Safari in v11. Return a noop then() so the async/await ESM code doesn't continue.
        // IS_ESM_BUILD is replaced at build time so this check doesn't happen in systemjs builds.
        return {
            then() {
                /* promise noop */
            },
        };
    }
    {
        opts.resourcesUrl = new URL('.', new URL(scriptElm.getAttribute('data-resources-url') || scriptElm.src, index.win.location.href)).href;
        {
            patchDynamicImport(opts.resourcesUrl, scriptElm);
        }
        if ( !index.win.customElements) {
            // module support, but no custom elements support (Old Edge)
            // @ts-ignore
            return Promise.resolve().then(function () { return require(/* webpackChunkName: "polyfills-dom" */ './dom-9d1bb6b4.js'); }).then(() => opts);
        }
    }
    return index.promiseResolve(opts);
};
const patchDynamicImport = (base, orgScriptElm) => {
    const importFunctionName = getDynamicImportFunction(index.NAMESPACE);
    try {
        // test if this browser supports dynamic imports
        // There is a caching issue in V8, that breaks using import() in Function
        // By generating a random string, we can workaround it
        // Check https://bugs.chromium.org/p/chromium/issues/detail?id=990810 for more info
        index.win[importFunctionName] = new Function('w', `return import(w);//${Math.random()}`);
    }
    catch (e) {
        // this shim is specifically for browsers that do support "esm" imports
        // however, they do NOT support "dynamic" imports
        // basically this code is for old Edge, v18 and below
        const moduleMap = new Map();
        index.win[importFunctionName] = (src) => {
            const url = new URL(src, base).href;
            let mod = moduleMap.get(url);
            if (!mod) {
                const script = index.doc.createElement('script');
                script.type = 'module';
                script.crossOrigin = orgScriptElm.crossOrigin;
                script.src = URL.createObjectURL(new Blob([`import * as m from '${url}'; window.${importFunctionName}.m = m;`], { type: 'application/javascript' }));
                mod = new Promise(resolve => {
                    script.onload = () => {
                        resolve(index.win[importFunctionName].m);
                        script.remove();
                    };
                });
                moduleMap.set(url, mod);
                index.doc.head.appendChild(script);
            }
            return mod;
        };
    }
};

patchBrowser().then(options => {
  appGlobals.globalScripts();
  return index.bootstrapLazy([["poductivity-client_6.cjs",[[1,"poductivity-client",{"audioElement":[16],"timestamp":[2],"isPlaying":[4,"is-playing"],"playbackRate":[2,"playback-rate"],"deviceIdentifier":[1,"device-identifier"],"userAgent":[1,"user-agent"],"optOutControl":[16],"noSubscribe":[4,"no-subscribe"],"messagesElement":[16],"debug":[4],"data":[16],"episode":[32],"slots":[32],"optionGroups":[32],"optOut":[32],"loading":[32],"loaded":[32],"timestampI":[32],"isPlayingI":[32],"internalDeviceIdentifier":[32],"dynamicOptionGroup":[32],"setEpisodeByFeed":[64],"setEpisodeById":[64],"close":[64],"isReady":[64]},[[8,"pagehide","onPageHide"],[8,"visibilitychange","onVisibilityChange"],[0,"optOutChanged","changeOptOut"]]],[0,"poductivity-messages",{"optionGroups":[16]}],[0,"poductivity-subscribe",{"showData":[16],"userAgent":[1,"user-agent"],"absolute":[4],"fill":[4],"debug":[4],"waiting":[32],"attemptOpenDefaultApp":[64],"show":[64]}],[0,"poductivity-opt-out-control",{"optOut":[1,"opt-out"],"up":[4],"right":[4],"isOpen":[32]}],[4,"poductivity-marquee",{"speed":[2],"active":[4],"uid":[1],"overflow":[32],"setOverflow":[64]}],[4,"poductivity-modal",{"absolute":[4],"fill":[4],"debug":[4],"isShown":[32],"isLoadingFrame":[32],"frameSrc":[32],"resolveI":[32],"rejectI":[32],"show":[64],"hide":[64],"forceClose":[64]},[[8,"message","receiveMessage"]]]]],["poductivity-input-range_3.cjs",[[1,"poductivity-player",{"episodeId":[1,"episode-id"],"feedUrl":[1,"feed-url"],"episodeGuid":[1,"episode-guid"],"accentColor":[1,"accent-color"],"horizontal":[4],"theme":[1],"useOsFont":[4,"use-os-font"],"debug":[4],"episode":[32],"isPlaying":[32],"isBuffering":[32],"currentTime":[32],"playbackRate":[32],"isLoading":[32],"loadingFailed":[32],"playError":[32],"play":[64],"pause":[64],"togglePlay":[64],"seekTo":[64],"seekRelative":[64],"setPlaybackRate":[64],"showEpisodeNotes":[64],"hideEpisodeNotes":[64]}],[0,"poductivity-input-range",{"value":[2],"min":[2],"max":[2],"step":[2],"disabled":[4]},[[1,"input","changed"],[1,"touchStart","startedInteracting"],[1,"mouseDown","startedInteracting"]]],[0,"poductivity-playback-rate-control",{"playbackRate":[2,"playback-rate"]}]]]], options);
});
