import { PopupController } from '../../utils/PopupController';
import { uuid } from '../../utils/utils';
export class ActionHandler {
  constructor(client) {
    this.client = client;
    this.popup = new PopupController(uuid());
  }
  async mediaPause() {
    this.client.controlAudio('pause');
    return true;
  }
  async mediaResume() {
    this.client.controlAudio('resume');
    return true;
  }
  async mediaSeekAbsolute(action) {
    var _a;
    this.client.controlAudio('seekAbsolute', ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.timestamp) || 0);
    return true;
  }
  async mediaSeekRelative(action) {
    var _a;
    this.client.controlAudio('seekRelative', ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.seconds) || 0);
    return true;
  }
  async modalFrame(action) {
    var _a;
    return await this.client.modalElement.show((_a = action.meta) === null || _a === void 0 ? void 0 : _a.frameSrc);
  }
  async modalPopup(action) {
    var _a;
    return await this.popup.show((_a = action.meta) === null || _a === void 0 ? void 0 : _a.frameSrc);
  }
  async optionGroupGoTo(action) {
    this.client.dynamicOptionGroup =
      this.client.optionGroups.find((og) => { var _a; return og.id === ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.optionGroupId); }) || null;
    return true;
  }
  async optionGroupHide(action, _option, optionGroup) {
    var _a;
    return !!this.client.editOptionGroup(optionGroup.id, {
      hide: true,
      hideMessage: ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.textContent) || '',
    });
  }
  async optionHide(_action, option, optionGroup) {
    return !!this.client.editOption(optionGroup.id, option.id, {
      hide: true,
    });
  }
  async externalUrl(action) {
    var _a;
    if (typeof ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.url) === 'string') {
      this.client.openExternalUrl.emit({ url: action.meta.url });
      if (window === null || window === void 0 ? void 0 : window.open) {
        window.open(action.meta.url);
      }
      return true;
    }
    return false;
  }
  async feedSubscribe(_action) {
    var _a;
    this.client.subscribeToFeed.emit({});
    if (!this.client.noSubscribe) {
      await ((_a = this.client.subscribeElement) === null || _a === void 0 ? void 0 : _a.attemptOpenDefaultApp());
    }
    return true;
  }
}
