import { Component, h, Prop, Host } from '@stencil/core';
export class PdMessages {
  constructor() {
    /**
     * The current opt out status.
     * This is set automatically by the client - DO NOT USE
     */
    this.optionGroups = [];
  }
  get hasMultipleOptionGroups() {
    return Array.isArray(this.optionGroups);
  }
  get filteredOptionGroups() {
    return (this.hasMultipleOptionGroups
      ? this.optionGroups
      : [this.optionGroups]);
  }
  getOptionGroupTitle(optionGroup) {
    return (!optionGroup.hide &&
      optionGroup.title && (h("poductivity-marquee", { class: "pd-option-group-title pd-option-group-text", active: true }, optionGroup.title)));
  }
  getOptionGroupHideMessage(optionGroup) {
    return (optionGroup.hide &&
      optionGroup.hideMessage && (h("div", { class: "pd-option-group-text pd-option-group-hidden-message" }, optionGroup.hideMessage)));
  }
  getOptionGroupOneTimeActedMessage(optionGroup) {
    return (!(optionGroup.hide && optionGroup.hideMessage) &&
      optionGroup.oneTime &&
      optionGroup.previouslyActed &&
      optionGroup.oneTimeActedMessage && (h("div", { class: "pd-option-group-text pd-option-group-hidden-message" }, optionGroup.oneTimeActedMessage)));
  }
  render() {
    return (h(Host, null, this.filteredOptionGroups.map((optionGroup) => {
      return (h("div", { class: "pd-messages-group" },
        this.getOptionGroupTitle(optionGroup),
        this.getOptionGroupHideMessage(optionGroup),
        this.getOptionGroupOneTimeActedMessage(optionGroup)));
    })));
  }
  static get is() { return "poductivity-messages"; }
  static get originalStyleUrls() { return {
    "$": ["./pd-messages.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["pd-messages.css"]
  }; }
  static get properties() { return {
    "optionGroups": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "OptionGroupData | OptionGroupData[]",
        "resolved": "OptionGroupData | OptionGroupData[]",
        "references": {
          "OptionGroupData": {
            "location": "import",
            "path": "../../slot.interface"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "The current opt out status.\nThis is set automatically by the client - DO NOT USE"
      },
      "defaultValue": "[]"
    }
  }; }
}
