import { Build } from '@stencil/core';
export class Logger {
  constructor(context, debug) {
    this.context = context;
    this.debug = typeof debug === 'boolean' ? debug : Build.isDev;
  }
  log(...params) {
    if (this.debug) {
      console.log(this.context, ...params);
    }
  }
  warn(...params) {
    console.warn(this.context, ...params);
  }
  error(...params) {
    console.error(this.context, ...params);
  }
  setDebug(debug) {
    this.debug = debug;
  }
}
