/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "./stencil-public-runtime";
import { OptionGroupData, OptOutType, PdData } from "./slot.interface";
import { AudioControlEventData, FeedSubscribeData, InputRangeChangeEventData, InputRangeInteractingEventData, LoadedEpisodeData, LoadingEpisodeDataFailed, OpenExternalUrlData, OptOutEventData, PerformActionData, PlaybackEventData, PlaybackRateEventData } from "./events.interface";
import { SubscribeShowData } from "./episode.interface";
export namespace Components {
    interface PoductivityClient {
        /**
          * Pass a reference to a <audio> element to have the client attach the necessary listeners and perform control action for you
         */
        "audioElement": HTMLAudioElement;
        /**
          * If integrating into an app, call this before destroying the webview to allow the client to flush it's caches. If integrating into the web, the client handles this itself using the Browser Visibility API
         */
        "close": () => Promise<void>;
        /**
          * Pass in a data object to use instead of contacting the API server For internal/debug use only
         */
        "data": PdData | null;
        /**
          * Enable debug mode. Shows a status panel in the client and adds extra console logging. For internal use only
         */
        "debug": boolean;
        /**
          * If integrating into an app, pass the device's native advertising ID here. If integrating into a web app, the client will handle generation and persistence of a device identifier for you
         */
        "deviceIdentifier": string;
        /**
          * If not using the audioElement prop, pass the current playback state here
         */
        "isPlaying": boolean;
        /**
          * Is the client ready?
         */
        "isReady": () => Promise<boolean>;
        /**
          * Optionally supply a <poductivity-messages> element positioned anywhere in the DOM. Will show in this element otherwise
         */
        "messagesElement": HTMLPoductivityMessagesElement | null;
        /**
          * Use to disable the standard Poductivity subscribe behaviour if you wish to capture and handle the subscribeToFeed event yourself
         */
        "noSubscribe": boolean;
        /**
          * Optionally supply a <poductivity-opt-out-control> element positioned anywhere in the DOM. Will show inside this element otherwise
         */
        "optOutControl": HTMLPoductivityOptOutControlElement | null;
        /**
          * If not using the audioElement prop, pass the current playback rate here
         */
        "playbackRate": number;
        /**
          * Set the current episode by feed URL and episode GUID.
         */
        "setEpisodeByFeed": (feedUrl: string, episodeGuid: string) => Promise<void>;
        /**
          * Set the current episode by Poductivity Episode ID
         */
        "setEpisodeById": (episodeId: string) => Promise<void>;
        /**
          * If not using the audioElement prop, pass the current audio timestamp here
         */
        "timestamp": number;
        /**
          * The User Agent your app uses. Only necessary when integrating into an app with a custom user agent. Will use the current browser's user agent if available.
         */
        "userAgent": string;
    }
    interface PoductivityInputRange {
        /**
          * Disable the input
         */
        "disabled": boolean;
        /**
          * The maximum value
         */
        "max": number;
        /**
          * The minimum value
         */
        "min": number;
        /**
          * The step between values
         */
        "step": number;
        /**
          * The input value
         */
        "value": number;
    }
    interface PoductivityMarquee {
        /**
          * Enable the animation
         */
        "active": boolean;
        /**
          * Force a recalculation of the overflow
         */
        "setOverflow": () => Promise<void>;
        /**
          * How many px should move per second?
         */
        "speed": number;
        /**
          * A unique ID for the component. Will be auto generated if not supplied
         */
        "uid": string;
    }
    interface PoductivityMessages {
        /**
          * The current opt out status. This is set automatically by the client - DO NOT USE
         */
        "optionGroups": OptionGroupData | OptionGroupData[];
    }
    interface PoductivityModal {
        /**
          * Position the modal absolute rather than fixed
         */
        "absolute": boolean;
        /**
          * Debug mode
         */
        "debug": boolean;
        /**
          * Fill all available space - no visible backdrop
         */
        "fill": boolean;
        /**
          * Hide the modal with a failed action result
         */
        "forceClose": () => Promise<void>;
        /**
          * Hide the modal. Specify whether the action was successful
          * @param message
         */
        "hide": (message: boolean) => Promise<void>;
        /**
          * Show the modal
          * @param frameSrc Optional source for the iframe
         */
        "show": (frameSrc?: string | null) => Promise<boolean>;
    }
    interface PoductivityOptOutControl {
        /**
          * The current opt out status
         */
        "optOut": OptOutType;
        /**
          * Make the dropdown's right edge align to the trigger
         */
        "right": boolean;
        /**
          * Make the dropdown appear above the trigger
         */
        "up": boolean;
    }
    interface PoductivityPlaybackRateControl {
        /**
          * The current rate
         */
        "playbackRate": number;
    }
    interface PoductivityPlayer {
        /**
          * Accent colour. Supply as any CSS supported colour format, eg. #ff0000
         */
        "accentColor": string;
        /**
          * Enable Debug mode. For internal use only
         */
        "debug": boolean;
        /**
          * The Episode GUID as specified in the feed
         */
        "episodeGuid": string;
        /**
          * The Poductivity Episode ID. Either this or feedUrl and episodeGuid are required
         */
        "episodeId": string;
        /**
          * The Feed URL
         */
        "feedUrl": string;
        /**
          * Hide the episode notes panel
         */
        "hideEpisodeNotes": () => Promise<void>;
        /**
          * Should the player be horizontal?
         */
        "horizontal": boolean;
        /**
          * Pause playback
         */
        "pause": () => Promise<void>;
        /**
          * Begin or resume playback
         */
        "play": () => Promise<void>;
        /**
          * Seek to a timestamp relative to the current playback position in seconds
         */
        "seekRelative": (seconds: number | string) => Promise<void>;
        /**
          * Seek to a specific timestamp in seconds
         */
        "seekTo": (timestamp: number | string, fastSeek?: boolean) => Promise<void>;
        /**
          * Show the episode notes panel
         */
        "setPlaybackRate": (playbackRate: number) => Promise<void>;
        /**
          * Show the episode notes panel
         */
        "showEpisodeNotes": () => Promise<void>;
        /**
          * Specify the theme to use. Defaults to 'light'.
         */
        "theme": 'dark' | 'light' | 'poductivity';
        /**
          * Either play or pause playback, depending on the current playback state
         */
        "togglePlay": () => Promise<void>;
        /**
          * Use the Operating System's default UI font instead of the Poductivity brand font
         */
        "useOsFont": boolean;
    }
    interface PoductivitySubscribe {
        /**
          * Position the modal absolute rather than fixed
         */
        "absolute": boolean;
        /**
          * Attempt to open the default app
         */
        "attemptOpenDefaultApp": () => Promise<boolean>;
        /**
          * Debug mode
         */
        "debug": boolean;
        /**
          * Fill all available space - no visible backdrop
         */
        "fill": boolean;
        /**
          * Show the modal
         */
        "show": () => Promise<boolean>;
        /**
          * Required. Data for the show to subscribe to
         */
        "showData": SubscribeShowData | null;
        /**
          * Required. The browser/app's user agent. Used for feature detection
         */
        "userAgent": string;
    }
}
declare global {
    interface HTMLPoductivityClientElement extends Components.PoductivityClient, HTMLStencilElement {
    }
    var HTMLPoductivityClientElement: {
        prototype: HTMLPoductivityClientElement;
        new (): HTMLPoductivityClientElement;
    };
    interface HTMLPoductivityInputRangeElement extends Components.PoductivityInputRange, HTMLStencilElement {
    }
    var HTMLPoductivityInputRangeElement: {
        prototype: HTMLPoductivityInputRangeElement;
        new (): HTMLPoductivityInputRangeElement;
    };
    interface HTMLPoductivityMarqueeElement extends Components.PoductivityMarquee, HTMLStencilElement {
    }
    var HTMLPoductivityMarqueeElement: {
        prototype: HTMLPoductivityMarqueeElement;
        new (): HTMLPoductivityMarqueeElement;
    };
    interface HTMLPoductivityMessagesElement extends Components.PoductivityMessages, HTMLStencilElement {
    }
    var HTMLPoductivityMessagesElement: {
        prototype: HTMLPoductivityMessagesElement;
        new (): HTMLPoductivityMessagesElement;
    };
    interface HTMLPoductivityModalElement extends Components.PoductivityModal, HTMLStencilElement {
    }
    var HTMLPoductivityModalElement: {
        prototype: HTMLPoductivityModalElement;
        new (): HTMLPoductivityModalElement;
    };
    interface HTMLPoductivityOptOutControlElement extends Components.PoductivityOptOutControl, HTMLStencilElement {
    }
    var HTMLPoductivityOptOutControlElement: {
        prototype: HTMLPoductivityOptOutControlElement;
        new (): HTMLPoductivityOptOutControlElement;
    };
    interface HTMLPoductivityPlaybackRateControlElement extends Components.PoductivityPlaybackRateControl, HTMLStencilElement {
    }
    var HTMLPoductivityPlaybackRateControlElement: {
        prototype: HTMLPoductivityPlaybackRateControlElement;
        new (): HTMLPoductivityPlaybackRateControlElement;
    };
    interface HTMLPoductivityPlayerElement extends Components.PoductivityPlayer, HTMLStencilElement {
    }
    var HTMLPoductivityPlayerElement: {
        prototype: HTMLPoductivityPlayerElement;
        new (): HTMLPoductivityPlayerElement;
    };
    interface HTMLPoductivitySubscribeElement extends Components.PoductivitySubscribe, HTMLStencilElement {
    }
    var HTMLPoductivitySubscribeElement: {
        prototype: HTMLPoductivitySubscribeElement;
        new (): HTMLPoductivitySubscribeElement;
    };
    interface HTMLElementTagNameMap {
        "poductivity-client": HTMLPoductivityClientElement;
        "poductivity-input-range": HTMLPoductivityInputRangeElement;
        "poductivity-marquee": HTMLPoductivityMarqueeElement;
        "poductivity-messages": HTMLPoductivityMessagesElement;
        "poductivity-modal": HTMLPoductivityModalElement;
        "poductivity-opt-out-control": HTMLPoductivityOptOutControlElement;
        "poductivity-playback-rate-control": HTMLPoductivityPlaybackRateControlElement;
        "poductivity-player": HTMLPoductivityPlayerElement;
        "poductivity-subscribe": HTMLPoductivitySubscribeElement;
    }
}
declare namespace LocalJSX {
    interface PoductivityClient {
        /**
          * Pass a reference to a <audio> element to have the client attach the necessary listeners and perform control action for you
         */
        "audioElement"?: HTMLAudioElement;
        /**
          * Pass in a data object to use instead of contacting the API server For internal/debug use only
         */
        "data"?: PdData | null;
        /**
          * Enable debug mode. Shows a status panel in the client and adds extra console logging. For internal use only
         */
        "debug"?: boolean;
        /**
          * If integrating into an app, pass the device's native advertising ID here. If integrating into a web app, the client will handle generation and persistence of a device identifier for you
         */
        "deviceIdentifier"?: string;
        /**
          * If not using the audioElement prop, pass the current playback state here
         */
        "isPlaying"?: boolean;
        /**
          * Optionally supply a <poductivity-messages> element positioned anywhere in the DOM. Will show in this element otherwise
         */
        "messagesElement"?: HTMLPoductivityMessagesElement | null;
        /**
          * Use to disable the standard Poductivity subscribe behaviour if you wish to capture and handle the subscribeToFeed event yourself
         */
        "noSubscribe"?: boolean;
        /**
          * Emitted when an action requests a change to audio control. Only required if not using the audioElement prop
         */
        "onAudioControl"?: (event: CustomEvent<AudioControlEventData>) => void;
        /**
          * Emitted when the episode data is loaded
         */
        "onLoadedEpisodeData"?: (event: CustomEvent<LoadedEpisodeData>) => void;
        /**
          * Emitted when the episode data is about to load
         */
        "onLoadingEpisodeData"?: (event: CustomEvent<void>) => void;
        /**
          * Emitted if the episode data fails to load
         */
        "onLoadingEpisodeDataFailed"?: (event: CustomEvent<LoadingEpisodeDataFailed>) => void;
        /**
          * Emitted when an action requests to open a URL in a new window. Only required when integrating into an app that won't support window.open
         */
        "onOpenExternalUrl"?: (event: CustomEvent<OpenExternalUrlData>) => void;
        /**
          * Emitted when an action is performed Only required if you want your app to also perform an action as a result
         */
        "onPerformAction"?: (event: CustomEvent<PerformActionData>) => void;
        /**
          * Emitted when an action requests to subscribe to a feed. Only required when wishing to override the default modal
         */
        "onSubscribeToFeed"?: (event: CustomEvent<FeedSubscribeData>) => void;
        /**
          * Optionally supply a <poductivity-opt-out-control> element positioned anywhere in the DOM. Will show inside this element otherwise
         */
        "optOutControl"?: HTMLPoductivityOptOutControlElement | null;
        /**
          * If not using the audioElement prop, pass the current playback rate here
         */
        "playbackRate"?: number;
        /**
          * If not using the audioElement prop, pass the current audio timestamp here
         */
        "timestamp"?: number;
        /**
          * The User Agent your app uses. Only necessary when integrating into an app with a custom user agent. Will use the current browser's user agent if available.
         */
        "userAgent"?: string;
    }
    interface PoductivityInputRange {
        /**
          * Disable the input
         */
        "disabled"?: boolean;
        /**
          * The maximum value
         */
        "max"?: number;
        /**
          * The minimum value
         */
        "min"?: number;
        /**
          * Emitted when the input changes
         */
        "onInputRangeChanged"?: (event: CustomEvent<InputRangeChangeEventData>) => void;
        /**
          * Emitted when the user begins or ends seeking
         */
        "onInputRangeInteracting"?: (event: CustomEvent<InputRangeInteractingEventData>) => void;
        /**
          * The step between values
         */
        "step"?: number;
        /**
          * The input value
         */
        "value"?: number;
    }
    interface PoductivityMarquee {
        /**
          * Enable the animation
         */
        "active"?: boolean;
        /**
          * How many px should move per second?
         */
        "speed"?: number;
        /**
          * A unique ID for the component. Will be auto generated if not supplied
         */
        "uid"?: string;
    }
    interface PoductivityMessages {
        /**
          * The current opt out status. This is set automatically by the client - DO NOT USE
         */
        "optionGroups"?: OptionGroupData | OptionGroupData[];
    }
    interface PoductivityModal {
        /**
          * Position the modal absolute rather than fixed
         */
        "absolute"?: boolean;
        /**
          * Debug mode
         */
        "debug"?: boolean;
        /**
          * Fill all available space - no visible backdrop
         */
        "fill"?: boolean;
    }
    interface PoductivityOptOutControl {
        /**
          * Emitted when the user changes their opt in status
         */
        "onOptOutChanged"?: (event: CustomEvent<OptOutEventData>) => void;
        /**
          * The current opt out status
         */
        "optOut"?: OptOutType;
        /**
          * Make the dropdown's right edge align to the trigger
         */
        "right"?: boolean;
        /**
          * Make the dropdown appear above the trigger
         */
        "up"?: boolean;
    }
    interface PoductivityPlaybackRateControl {
        /**
          * Emitted when the user changes their opt in status
         */
        "onPlaybackRateChange"?: (event: CustomEvent<PlaybackRateEventData>) => void;
        /**
          * The current rate
         */
        "playbackRate"?: number;
    }
    interface PoductivityPlayer {
        /**
          * Accent colour. Supply as any CSS supported colour format, eg. #ff0000
         */
        "accentColor"?: string;
        /**
          * Enable Debug mode. For internal use only
         */
        "debug"?: boolean;
        /**
          * The Episode GUID as specified in the feed
         */
        "episodeGuid"?: string;
        /**
          * The Poductivity Episode ID. Either this or feedUrl and episodeGuid are required
         */
        "episodeId"?: string;
        /**
          * The Feed URL
         */
        "feedUrl"?: string;
        /**
          * Should the player be horizontal?
         */
        "horizontal"?: boolean;
        /**
          * Emitted when playback is started or paused
         */
        "onPdPlayback"?: (event: CustomEvent<PlaybackEventData>) => void;
        /**
          * Specify the theme to use. Defaults to 'light'.
         */
        "theme"?: 'dark' | 'light' | 'poductivity';
        /**
          * Use the Operating System's default UI font instead of the Poductivity brand font
         */
        "useOsFont"?: boolean;
    }
    interface PoductivitySubscribe {
        /**
          * Position the modal absolute rather than fixed
         */
        "absolute"?: boolean;
        /**
          * Debug mode
         */
        "debug"?: boolean;
        /**
          * Fill all available space - no visible backdrop
         */
        "fill"?: boolean;
        /**
          * Required. Data for the show to subscribe to
         */
        "showData"?: SubscribeShowData | null;
        /**
          * Required. The browser/app's user agent. Used for feature detection
         */
        "userAgent"?: string;
    }
    interface IntrinsicElements {
        "poductivity-client": PoductivityClient;
        "poductivity-input-range": PoductivityInputRange;
        "poductivity-marquee": PoductivityMarquee;
        "poductivity-messages": PoductivityMessages;
        "poductivity-modal": PoductivityModal;
        "poductivity-opt-out-control": PoductivityOptOutControl;
        "poductivity-playback-rate-control": PoductivityPlaybackRateControl;
        "poductivity-player": PoductivityPlayer;
        "poductivity-subscribe": PoductivitySubscribe;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            "poductivity-client": LocalJSX.PoductivityClient & JSXBase.HTMLAttributes<HTMLPoductivityClientElement>;
            "poductivity-input-range": LocalJSX.PoductivityInputRange & JSXBase.HTMLAttributes<HTMLPoductivityInputRangeElement>;
            "poductivity-marquee": LocalJSX.PoductivityMarquee & JSXBase.HTMLAttributes<HTMLPoductivityMarqueeElement>;
            "poductivity-messages": LocalJSX.PoductivityMessages & JSXBase.HTMLAttributes<HTMLPoductivityMessagesElement>;
            "poductivity-modal": LocalJSX.PoductivityModal & JSXBase.HTMLAttributes<HTMLPoductivityModalElement>;
            "poductivity-opt-out-control": LocalJSX.PoductivityOptOutControl & JSXBase.HTMLAttributes<HTMLPoductivityOptOutControlElement>;
            "poductivity-playback-rate-control": LocalJSX.PoductivityPlaybackRateControl & JSXBase.HTMLAttributes<HTMLPoductivityPlaybackRateControlElement>;
            "poductivity-player": LocalJSX.PoductivityPlayer & JSXBase.HTMLAttributes<HTMLPoductivityPlayerElement>;
            "poductivity-subscribe": LocalJSX.PoductivitySubscribe & JSXBase.HTMLAttributes<HTMLPoductivitySubscribeElement>;
        }
    }
}
