import { EventEmitter } from '../../stencil-public-runtime';
import { InputRangeChangeEventData, InputRangeInteractingEventData } from '../../events.interface';
export declare class PdInputRange {
  /**
   * The input value
   */
  value: number;
  /**
   * The minimum value
   */
  min: number;
  /**
   * The maximum value
   */
  max: number;
  /**
   * The step between values
   */
  step: number;
  /**
   * Disable the input
   */
  disabled: boolean;
  /**
   * Emitted when the input changes
   */
  inputRangeChanged: EventEmitter<InputRangeChangeEventData>;
  /**
   * Emitted when the user begins or ends seeking
   */
  inputRangeInteracting: EventEmitter<InputRangeInteractingEventData>;
  get style(): {
    '--min': string;
    '--max': string;
    '--val': string;
  };
  changed(e: UIEvent): void;
  startedInteracting(): void;
  render(): any;
}
