/**
 * @slot default - The content to slide
 */
export declare class PdMarquee {
  /**
   * How many px should move per second?
   */
  speed: number;
  /**
   * Enable the animation
   */
  active: boolean;
  /**
   * A unique ID for the component. Will be auto generated if not supplied
   */
  uid: string;
  private overflow;
  private contentEl;
  private resizeObserver;
  private fallbackId;
  constructor();
  protected componentDidLoad(): void;
  protected disconnectedCallback(): void;
  protected componentWillUpdate(): void;
  /**
   * Force a recalculation of the overflow
   */
  setOverflow(): Promise<void>;
  get contentClasses(): string;
  get contentStyle(): Partial<CSSStyleDeclaration>;
  private get internalId();
  get animationName(): string;
  get duration(): number;
  render(): any;
}
