/**
 * @slot default - Optional HTML content for the modal if not using the iframe
 */
export declare class PdModal {
  /**
   * Position the modal absolute rather than fixed
   */
  absolute: boolean;
  /**
   * Fill all available space - no visible backdrop
   */
  fill: boolean;
  /**
   * Debug mode
   */
  debug: boolean;
  isShown: boolean;
  isLoadingFrame: boolean;
  frameSrc: string | null;
  resolveI: ((message: boolean) => void) | null;
  rejectI: ((message: boolean) => void) | null;
  private frameElement;
  private iframeResizeInitiated;
  private logger;
  private instanceId;
  constructor();
  componentDidRender(): void;
  /**
   * Show the modal
   * @param frameSrc Optional source for the iframe
   */
  show(frameSrc?: string | null): Promise<boolean>;
  /**
   * Hide the modal. Specify whether the action was successful
   * @param message
   */
  hide(message: boolean): Promise<void>;
  /**
   * Hide the modal with a failed action result
   */
  forceClose(): Promise<void>;
  protected receiveMessage(e: MessageEvent): void;
  private get frameAllowPolicy();
  private get fullFrameSrc();
  private get wrapperClasses();
  private backdropClicked;
  private frameLoaded;
  render(): any;
}
