import { SubscribeShowData } from '../../episode.interface';
export declare class PdSubscribe {
  /**
   * Required. Data for the show to subscribe to
   */
  showData: SubscribeShowData | null;
  /**
   * Required. The browser/app's user agent. Used for feature detection
   */
  userAgent: string;
  /**
   * Position the modal absolute rather than fixed
   */
  absolute: boolean;
  /**
   * Fill all available space - no visible backdrop
   */
  fill: boolean;
  /**
   * Debug mode
   */
  debug: boolean;
  waiting: boolean;
  private modal;
  private logger;
  constructor();
  /**
   * Attempt to open the default app
   */
  attemptOpenDefaultApp(): Promise<boolean>;
  /**
   * Show the modal
   */
  show(): Promise<boolean>;
  private linkClicked;
  get fullFeedUrl(): string;
  get applePodcastsUrl(): string;
  get spotifyUrl(): string;
  get spotifyUri(): string;
  get googlePodcastsUrl(): string;
  get pocketCastsUrl(): string;
  get overcastUrl(): string;
  get isAppleHandheld(): boolean;
  get isMac(): boolean;
  get isAndroid(): boolean;
  private getButton;
  render(): any;
}
