export interface DeviceInfo {
  deviceIdentifier: string;
  listenerAccessToken?: string;
}
export interface DeviceCacheItem extends DeviceInfo {
  working: boolean;
  failed: boolean;
}
export interface DeviceServiceInterface {
  getDeviceInfo(): Promise<DeviceInfo>;
}
declare class DeviceService implements DeviceServiceInterface {
  private cache;
  private logger;
  private debug;
  constructor(debug?: boolean);
  /**
   * listenerAccessToken will only be set if this is running
   * on a trusted domain - otherwise will be undefined
   */
  getDeviceInfo(maxTime?: number): Promise<DeviceInfo>;
  private getCache;
  private setCache;
  private getFrameSrc;
  private createIdentifierFrame;
}
declare const _default: DeviceService;
export default _default;
