# poductivity-modal

A modal web component. For internal use only.

<!-- Auto Generated Below -->


## Properties

| Property   | Attribute  | Description                                    | Type      | Default |
| ---------- | ---------- | ---------------------------------------------- | --------- | ------- |
| `absolute` | `absolute` | Position the modal absolute rather than fixed  | `boolean` | `false` |
| `debug`    | `debug`    | Debug mode                                     | `boolean` | `false` |
| `fill`     | `fill`     | Fill all available space - no visible backdrop | `boolean` | `false` |


## Methods

### `forceClose() => Promise<void>`

Hide the modal with a failed action result

#### Returns

Type: `Promise<void>`



### `hide(message: boolean) => Promise<void>`

Hide the modal. Specify whether the action was successful

#### Returns

Type: `Promise<void>`



### `show(frameSrc?: string | null) => Promise<boolean>`

Show the modal

#### Returns

Type: `Promise<boolean>`




## Slots

| Slot        | Description                                                 |
| ----------- | ----------------------------------------------------------- |
| `"default"` | Optional HTML content for the modal if not using the iframe |


## Dependencies

### Used by

 - [poductivity-client](../pd-client)
 - [poductivity-player](../pd-player)
 - [poductivity-subscribe](../pd-subscribe)

### Graph
```mermaid
graph TD;
  poductivity-client --> poductivity-modal
  poductivity-player --> poductivity-modal
  poductivity-subscribe --> poductivity-modal
  style poductivity-modal fill:#f9f,stroke:#333,stroke-width:4px
```

----------------------------------------------

Copyright Poductivity Limited, All Rights Reserved
