# poductivity-opt-out-control

Allows placing the Poductivity opt out controls outside of the client element. For internal use only.

<!-- Auto Generated Below -->


## Properties

| Property | Attribute | Description                                         | Type                         | Default     |
| -------- | --------- | --------------------------------------------------- | ---------------------------- | ----------- |
| `optOut` | `opt-out` | The current opt out status                          | `"" \| "listener" \| "show"` | `undefined` |
| `right`  | `right`   | Make the dropdown's right edge align to the trigger | `boolean`                    | `false`     |
| `up`     | `up`      | Make the dropdown appear above the trigger          | `boolean`                    | `false`     |


## Events

| Event           | Description                                       | Type                           |
| --------------- | ------------------------------------------------- | ------------------------------ |
| `optOutChanged` | Emitted when the user changes their opt in status | `CustomEvent<OptOutEventData>` |


## Dependencies

### Used by

 - [poductivity-client](../pd-client)
 - [poductivity-player](../pd-player)

### Graph
```mermaid
graph TD;
  poductivity-client --> poductivity-opt-out-control
  poductivity-player --> poductivity-opt-out-control
  style poductivity-opt-out-control fill:#f9f,stroke:#333,stroke-width:4px
```

----------------------------------------------

Copyright Poductivity Limited, All Rights Reserved
